import React from 'react';
import { clamp } from 'ramda';
import { Box, Segment } from '../elements';
import { Loader } from '../modules';
import { useConfig } from './context';
import { useWidget } from './widgets';
import styled from 'styled-components';
var WidgetContent = function (_a) {
    var config = _a.config;
    var Component = useWidget(config.as);
    return React.createElement(Component, { config: config }, config.content);
};
var WidgetSegment = styled(Segment)({
    overflowY: 'auto',
    margin: 0,
    display: 'flex',
    flexFlow: 'column nowrap',
    alignItems: 'stretch',
    '& > small': {
        paddingBottom: '1em',
        textAlign: 'center',
    },
});
var clampSize = function (size) { return (size ? clamp(1, 10, size) : 1); };
export var Widget = function (_a) {
    var config = _a.config;
    var _b = useConfig().defaultSize, defaultSize = _b === void 0 ? 200 : _b;
    var width = clampSize(config.size) * defaultSize + 'px';
    var height = defaultSize + 'px';
    return (React.createElement(Box, { width: width, height: height, padded: true, stretched: true },
        React.createElement(WidgetSegment, { raised: !config.basic, color: config.backgroundColor },
            config.title && React.createElement("small", null, config.title),
            React.createElement(React.Suspense, { fallback: React.createElement(Loader, { active: true }) },
                React.createElement(WidgetContent, { config: config })))));
};
